# AbstractDifferentiation

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaDiff.github.io/AbstractDifferentiation.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaDiff.github.io/AbstractDifferentiation.jl/dev)
[![CI](https://github.com/JuliaDiff/AbstractDifferentiation.jl/actions/workflows/CI.yml/badge.svg?branch=master)](https://github.com/JuliaDiff/AbstractDifferentiation.jl/actions/workflows/CI.yml?query=branch%3Amaster)
[![Coverage](https://codecov.io/gh/JuliaDiff/AbstractDifferentiation.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaDiff/AbstractDifferentiation.jl)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/invenia/BlueStyle)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

## Motivation

This is a package that implements an abstract interface for differentiation in Julia. This is particularly useful for implementing abstract algorithms requiring derivatives, gradients, jacobians, Hessians or multiple of those without depending on specific automatic differentiation packages' user interfaces.

Julia has more (automatic) differentiation packages than you can count on 2 hands. Different packages have different user interfaces. Therefore, having a backend-agnostic interface to request the function value and its gradient for example is necessary to avoid a combinatorial explosion of code when trying to support every differentiation package in Julia in every algorithm package requiring gradients. For higher order derivatives, the situation is even more dire since you can combine any 2 differentiation backends together to create a new higher-order backend.

## Getting started

  - If you are an autodiff user and want to write code in a backend-agnostic way, read the _user guide_ in the docs.
  - If you are an autodiff developer and want your backend to implement the interface, read the _implementer guide_ in the docs (still in construction).

## Citing this package

If you use this package in your work, please cite the package:

```bib
@article{schafer2021abstractdifferentiation,
  title={AbstractDifferentiation. jl: Backend-Agnostic Differentiable Programming in Julia},
  author={Sch{\"a}fer, Frank and Tarek, Mohamed and White, Lyndon and Rackauckas, Chris},
  journal={NeurIPS 2021 Differentiable Programming Workshop},
  year={2021}
}
```

using AbstractDifferentiation
using Test
using ForwardDiff

@testset "ForwardDiffBackend" begin
    backends = [
        @inferred(AD.ForwardDiffBackend())
        @inferred(AD.ForwardDiffBackend(; chunksize=Val{1}()))
    ]
    @testset for backend in backends
        @test backend isa AD.AbstractForwardMode

        @testset "Derivative" begin
            test_derivatives(backend)
        end
        @testset "Gradient" begin
            test_gradients(backend)
        end
        @testset "Jacobian" begin
            test_jacobians(backend)
        end
        @testset "Hessian" begin
            test_hessians(backend)
        end
        @testset "jvp" begin
            test_jvp(backend; vaugmented=true)
        end
        @testset "j′vp" begin
            test_j′vp(backend)
        end
        @testset "Lazy Derivative" begin
            test_lazy_derivatives(backend)
        end
        @testset "Lazy Gradient" begin
            test_lazy_gradients(backend)
        end
        @testset "Lazy Jacobian" begin
            test_lazy_jacobians(backend; vaugmented=true)
        end
        @testset "Lazy Hessian" begin
            test_lazy_hessians(backend)
        end
    end
end

using AbstractDifferentiation
using Test
using FiniteDifferences, ForwardDiff, Zygote

const AD = AbstractDifferentiation
const FDM = FiniteDifferences

## FiniteDifferences
struct FDMBackend1{A} <: AD.AbstractFiniteDifference
    alg::A
end
FDMBackend1() = FDMBackend1(central_fdm(5, 1))
const fdm_backend1 = FDMBackend1()
# Minimal interface
AD.@primitive function jacobian(ab::FDMBackend1, f, xs...)
    return FDM.jacobian(ab.alg, f, xs...)
end

struct FDMBackend2{A} <: AD.AbstractFiniteDifference
    alg::A
end
FDMBackend2() = FDMBackend2(central_fdm(5, 1))
const fdm_backend2 = FDMBackend2()
AD.@primitive function pushforward_function(ab::FDMBackend2, f, xs...)
    return function (vs)
        ws = FDM.jvp(ab.alg, f, tuple.(xs, vs)...)
        return length(xs) == 1 ? (ws,) : ws
    end
end

struct FDMBackend3{A} <: AD.AbstractFiniteDifference
    alg::A
end
FDMBackend3() = FDMBackend3(central_fdm(5, 1))
const fdm_backend3 = FDMBackend3()
AD.@primitive function pullback_function(ab::FDMBackend3, f, xs...)
    return function (vs)
        # Supports only single output
        if vs isa AbstractVector
            return FDM.j′vp(ab.alg, f, vs, xs...)
        else
            return FDM.j′vp(ab.alg, f, only(vs), xs...)
        end
    end
end
##


## ForwardDiff
struct ForwardDiffBackend1 <: AD.AbstractForwardMode end
const forwarddiff_backend1 = ForwardDiffBackend1()
AD.@primitive function jacobian(ab::ForwardDiffBackend1, f, xs)
    if xs isa Number
        return (ForwardDiff.derivative(f, xs),)
    elseif xs isa AbstractArray
        out = f(xs)
        if out isa Number
            return (adjoint(ForwardDiff.gradient(f, xs)),)
        else
            return (ForwardDiff.jacobian(f, xs),)
        end
    elseif xs isa Tuple
        error(typeof(xs))      
    else
        error(typeof(xs)) 
    end
end
AD.primal_value(::ForwardDiffBackend1, ::Any, f, xs) = ForwardDiff.value.(f(xs...))

struct ForwardDiffBackend2 <: AD.AbstractForwardMode end
const forwarddiff_backend2 = ForwardDiffBackend2()
AD.@primitive function pushforward_function(ab::ForwardDiffBackend2, f, xs...)
    # jvp = f'(x)*v, i.e., differentiate f(x + h*v) wrt h at 0
    return function (vs)
        if xs isa Tuple
            @assert length(xs) <= 2
            if length(xs) == 1
                (ForwardDiff.derivative(h->f(xs[1]+h*vs[1]),0),)
            else
                ForwardDiff.derivative(h->f(xs[1]+h*vs[1], xs[2]+h*vs[2]),0)
            end
        else
            ForwardDiff.derivative(h->f(xs+h*vs),0)
        end
    end
end
AD.primal_value(::ForwardDiffBackend2, ::Any, f, xs) = ForwardDiff.value.(f(xs...))
##

## Zygote
struct ZygoteBackend1 <: AD.AbstractReverseMode end
const zygote_backend1 = ZygoteBackend1()
AD.@primitive function pullback_function(ab::ZygoteBackend1, f, xs...)
    return function (vs)
        # Supports only single output
        _, back = Zygote.pullback(f, xs...)
        if vs isa AbstractVector
            back(vs)
        else
            back(only(vs))
        end
    end
end

@testset "defaults" begin
    @testset "Utils" begin
        test_higher_order_backend(fdm_backend1, fdm_backend2, fdm_backend3, zygote_backend1, forwarddiff_backend2)
    end
    @testset "FiniteDifferences" begin
        @testset "Derivative" begin
            test_derivatives(fdm_backend1)
            test_derivatives(fdm_backend2)
            test_derivatives(fdm_backend3)
        end
        @testset "Gradient" begin
            test_gradients(fdm_backend1)
            test_gradients(fdm_backend2)
            test_gradients(fdm_backend3)
        end
        @testset "Jacobian" begin
            test_jacobians(fdm_backend1)
            test_jacobians(fdm_backend2)
            test_jacobians(fdm_backend3)
        end
        @testset "Hessian" begin
            test_hessians(fdm_backend1)
            test_hessians(fdm_backend2)
            test_hessians(fdm_backend3)
        end
        @testset "jvp" begin
            test_jvp(fdm_backend1, test_types=false)
            test_jvp(fdm_backend2; vaugmented=true)
            test_jvp(fdm_backend3)
        end
        @testset "j′vp" begin
            test_j′vp(fdm_backend1)
            test_j′vp(fdm_backend2)
            test_j′vp(fdm_backend3)
        end
        @testset "Lazy Derivative" begin
            test_lazy_derivatives(fdm_backend1)
            test_lazy_derivatives(fdm_backend2)
            test_lazy_derivatives(fdm_backend3)
        end
        @testset "Lazy Gradient" begin
            test_lazy_gradients(fdm_backend1)
            test_lazy_gradients(fdm_backend2)
            test_lazy_gradients(fdm_backend3)
        end
        @testset "Lazy Jacobian" begin
            test_lazy_jacobians(fdm_backend1)
            test_lazy_jacobians(fdm_backend2; vaugmented=true)
            test_lazy_jacobians(fdm_backend3)
        end
        @testset "Lazy Hessian" begin
            test_lazy_hessians(fdm_backend1)
            test_lazy_hessians(fdm_backend2)
            test_lazy_hessians(fdm_backend3)
        end
    end
    @testset "ForwardDiff" begin
        @testset "Derivative" begin
            test_derivatives(forwarddiff_backend1; multiple_inputs=false)
            test_derivatives(forwarddiff_backend2)
        end
        @testset "Gradient" begin
            test_gradients(forwarddiff_backend1; multiple_inputs=false)
            test_gradients(forwarddiff_backend2)
        end
        @testset "Jacobian" begin
            test_jacobians(forwarddiff_backend1; multiple_inputs=false)
            test_jacobians(forwarddiff_backend2)
        end
        @testset "Hessian" begin
            test_hessians(forwarddiff_backend1; multiple_inputs=false)
            test_hessians(forwarddiff_backend2)
        end
        @testset "jvp" begin
            test_jvp(forwarddiff_backend1; multiple_inputs=false)
            test_jvp(forwarddiff_backend2; vaugmented=true)
        end
        @testset "j′vp" begin
            test_j′vp(forwarddiff_backend1; multiple_inputs=false)
            test_j′vp(forwarddiff_backend2)
        end
        @testset "Lazy Derivative" begin
            test_lazy_derivatives(forwarddiff_backend1; multiple_inputs=false)
            test_lazy_derivatives(forwarddiff_backend2)
        end
        @testset "Lazy Gradient" begin
            test_lazy_gradients(forwarddiff_backend1; multiple_inputs=false)
            test_lazy_gradients(forwarddiff_backend2)
        end
        @testset "Lazy Jacobian" begin
            test_lazy_jacobians(forwarddiff_backend1; multiple_inputs=false)
            test_lazy_jacobians(forwarddiff_backend2; vaugmented=true)
        end
        @testset "Lazy Hessian" begin
            test_lazy_hessians(forwarddiff_backend1; multiple_inputs=false)
            test_lazy_hessians(forwarddiff_backend2)
        end
    end
    @testset "Zygote" begin
        @testset "Derivative" begin
            test_derivatives(zygote_backend1)
        end
        @testset "Gradient" begin
            test_gradients(zygote_backend1)
        end
        @testset "Jacobian" begin
            test_jacobians(zygote_backend1)
        end
        @testset "Hessian" begin
            # Zygote over Zygote problems
            backends = AD.HigherOrderBackend((forwarddiff_backend2,zygote_backend1))
            test_hessians(backends)
            backends = AD.HigherOrderBackend((zygote_backend1,forwarddiff_backend1))
            test_hessians(backends)
            # fails:
            # backends = AD.HigherOrderBackend((zygote_backend1,forwarddiff_backend2))
            # test_hessians(backends)
        end
        @testset "jvp" begin
            test_jvp(zygote_backend1)
        end
        @testset "j′vp" begin
            test_j′vp(zygote_backend1)
        end
        @testset "Lazy Derivative" begin
            test_lazy_derivatives(zygote_backend1)
        end
        @testset "Lazy Gradient" begin
            test_lazy_gradients(zygote_backend1)
        end
        @testset "Lazy Jacobian" begin
            test_lazy_jacobians(zygote_backend1)
        end
        @testset "Lazy Hessian" begin
            # Zygote over Zygote problems
            backends = AD.HigherOrderBackend((forwarddiff_backend2,zygote_backend1))
            test_lazy_hessians(backends)
            backends = AD.HigherOrderBackend((zygote_backend1,forwarddiff_backend1))
            test_lazy_hessians(backends)
        end
    end
end

module AbstractDifferentiationTrackerExt

if isdefined(Base, :get_extension)
    import AbstractDifferentiation as AD
    using Tracker: Tracker
else
    import ..AbstractDifferentiation as AD
    using ..Tracker: Tracker
end

function AD.second_lowest(::AD.TrackerBackend)
    return throw(ArgumentError("Tracker backend does not support nested differentiation."))
end

AD.primal_value(x::Tracker.TrackedReal) = Tracker.data(x)
AD.primal_value(x::Tracker.TrackedArray) = Tracker.data(x)
AD.primal_value(x::AbstractArray{<:Tracker.TrackedReal}) = Tracker.data.(x)

AD.@primitive function pullback_function(ba::AD.TrackerBackend, f, xs...)
    value, back = Tracker.forward(f, xs...)
    function pullback(ws)
        if ws isa Tuple && !(value isa Tuple) 
            map(Tracker.data, back(only(ws)))
        else
            map(Tracker.data, back(ws))
        end
    end
    return pullback
end

function AD.derivative(::AD.TrackerBackend, f, xs::Number...)
    return Tracker.data.(Tracker.gradient(f, xs...))
end

function AD.gradient(::AD.TrackerBackend, f, xs::AbstractVector...)
    return Tracker.data.(Tracker.gradient(f, xs...))
end

end # module

using AbstractDifferentiation
using Test
using Tracker

@testset "TrackerBackend" begin
    backends = [@inferred(AD.TrackerBackend())]
    @testset for backend in backends
        @testset "errors when nested" begin
            @test_throws ArgumentError AD.second_lowest(backend)
            @test_throws ArgumentError AD.hessian(backend, sum, randn(3))
        end
        @testset "primal_value for array of tracked reals" begin
            @test AD.primal_value([Tracker.TrackedReal(1.0)]) isa Vector{Float64}
            @test AD.primal_value(fill(Tracker.TrackedReal(1.0), 1, 1)) isa Matrix{Float64}
        end
        @testset "Derivative" begin
            test_derivatives(backend)
        end
        @testset "Gradient" begin
            test_gradients(backend)
        end
        @testset "Jacobian" begin
            test_jacobians(backend)
        end
        @testset "jvp" begin
            test_jvp(backend)
        end
        @testset "j′vp" begin
            test_j′vp(backend)
        end
        @testset "Lazy Derivative" begin
            test_lazy_derivatives(backend)
        end
        @testset "Lazy Gradient" begin
            test_lazy_gradients(backend)
        end
        @testset "Lazy Jacobian" begin
            test_lazy_jacobians(backend)
        end
    end
end

using AbstractDifferentiation
using Documenter

DocMeta.setdocmeta!(AbstractDifferentiation, :DocTestSetup, :(using AbstractDifferentiation); recursive=true)

generated_path = joinpath(@__DIR__, "src")
base_url = "https://github.com/JuliaDiff/AbstractDifferentiation.jl/blob/master/"
isdir(generated_path) || mkdir(generated_path)

open(joinpath(generated_path, "index.md"), "w") do io
    # Point to source license file
    println(
        io,
        """
        ```@meta
        EditURL = "$(base_url)README.md"
        ```
        """,
    )
    # Write the contents out below the meta block
    for line in eachline(joinpath(dirname(@__DIR__), "README.md"))
        println(io, line)
    end
end

makedocs(;
    modules=[AbstractDifferentiation],
    authors="Mohamed Tarek <mohamed82008@gmail.com> and contributors",
    repo="https://github.com/JuliaDiff/AbstractDifferentiation.jl/blob/{commit}{path}#{line}",
    sitename="AbstractDifferentiation.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://JuliaDiff.github.io/AbstractDifferentiation.jl",
        edit_link="master",
        assets=String[],
    ),
    pages=[
        "Home" => "index.md",
        "API reference" => "api.md",
    ],
)

deploydocs(;
    repo="github.com/JuliaDiff/AbstractDifferentiation.jl",
    devbranch="master",
)

using AbstractDifferentiation
using ChainRulesCore
using Test
using Zygote

@testset "ReverseRuleConfigBackend(ZygoteRuleConfig())" begin
    backends = [@inferred(AD.ZygoteBackend())]
    @testset for backend in backends
        @testset "Derivative" begin
            test_derivatives(backend)
        end
        @testset "Gradient" begin
            test_gradients(backend)
        end
        @testset "Jacobian" begin
            test_jacobians(backend)
        end
        @testset "jvp" begin
            test_jvp(backend)
        end
        @testset "j′vp" begin
            test_j′vp(backend)
        end
        @testset "Second derivative" begin
            test_second_derivatives(backend)
        end
        @testset "Lazy Derivative" begin
            test_lazy_derivatives(backend)
        end
        @testset "Lazy Gradient" begin
            test_lazy_gradients(backend)
        end
        @testset "Lazy Jacobian" begin
            test_lazy_jacobians(backend)
        end
    end

    # issue #69
    @testset "Zygote context" begin
        ad = AD.ZygoteBackend()

        # example in #69: context is not mutated
        @test ad.ruleconfig.context.cache === nothing
        @test AD.derivative(ad, exp, 1.0) === (exp(1.0),)
        @test ad.ruleconfig.context.cache === nothing
        @test AD.derivative(ad, exp, 1.0) === (exp(1.0),)
        @test ad.ruleconfig.context.cache === nothing

        # Jacobian computation still works
        # https://github.com/JuliaDiff/AbstractDifferentiation.jl/pull/70#issuecomment-1449481724
        function f(x, a)
            r = Ref(x)
            r[] = r[] + r[]
            r[] = r[] * a
            return r[]
        end
        @test AD.jacobian(ad, f, [1, 2, 3], 3) ==
            ([6.0 0.0 0.0; 0.0 6.0 0.0; 0.0 0.0 6.0], [2.0, 4.0, 6.0])
    end

    # issue #57
    @testset "primal computation in rrule" begin
        function myfunc(x)
            @info "This should not be logged if I have an rrule"
            return x
        end
        ChainRulesCore.rrule(::typeof(myfunc), x) = (x, (y -> (NoTangent(), y)))

        @test_logs Zygote.gradient(myfunc, 1) # nothing is logged
        @test_logs AD.derivative(AD.ZygoteBackend(), myfunc, 1) # nothing is logged
    end
end

module AbstractDifferentiationFiniteDifferencesExt

if isdefined(Base, :get_extension)
    import AbstractDifferentiation as AD
    using FiniteDifferences: FiniteDifferences
else
    import ..AbstractDifferentiation as AD
    using ..FiniteDifferences: FiniteDifferences
end

"""
    FiniteDifferencesBackend(method=FiniteDifferences.central_fdm(5, 1))

Create an AD backend that uses forward mode with FiniteDifferences.jl.
"""
AD.FiniteDifferencesBackend() = AD.FiniteDifferencesBackend(FiniteDifferences.central_fdm(5, 1))

AD.@primitive function jacobian(ba::AD.FiniteDifferencesBackend, f, xs...)
    return FiniteDifferences.jacobian(ba.method, f, xs...)
end

function AD.pushforward_function(ba::AD.FiniteDifferencesBackend, f, xs...)
    return function pushforward(vs)
        ws = FiniteDifferences.jvp(ba.method, f, tuple.(xs, vs)...)
        return length(xs) == 1 ? (ws,) : ws
    end
end

function AD.pullback_function(ba::AD.FiniteDifferencesBackend, f, xs...)
    function pullback(vs)
        return FiniteDifferences.j′vp(ba.method, f, vs, xs...)
    end
end

# Better performance: issue #87
function AD.derivative(ba::AD.FiniteDifferencesBackend, f::TF, x::Real) where {TF<:Function}
    return (ba.method(f, x),)
end

end # module

module AbstractDifferentiationChainRulesCoreExt

import AbstractDifferentiation as AD
using ChainRulesCore: ChainRulesCore

AD.@primitive function value_and_pullback_function(
    ba::AD.ReverseRuleConfigBackend, f, xs...
)
    value, back = ChainRulesCore.rrule_via_ad(AD.ruleconfig(ba), f, xs...)
    function rrule_pullback(vs)
        _vs = if vs isa Tuple && !(value isa Tuple)
            only(vs)
        else
            vs
        end
        return Base.tail(back(_vs))
    end
    return value, rrule_pullback
end

end # module

module AbstractDifferentiationZygoteExt

if isdefined(Base, :get_extension)
    import AbstractDifferentiation as AD
    using Zygote: Zygote
else
    import ..AbstractDifferentiation as AD
    using ..Zygote: Zygote
end

AD.ZygoteBackend() = AD.ReverseRuleConfigBackend(Zygote.ZygoteRuleConfig())

# Context should not persist between different AD calls: fixes #69
function AD.ruleconfig(::AD.ReverseRuleConfigBackend{<:Zygote.ZygoteRuleConfig})
    return Zygote.ZygoteRuleConfig()
end

end # module

"""
    FiniteDifferencesBackend{M}

AD backend that uses forward mode with FiniteDifferences.jl.

The type parameter `M` is the type of the method used to perform finite differences.

!!! note
    To be able to use this backend, you have to load FiniteDifferences.
"""
struct FiniteDifferencesBackend{M} <: AbstractFiniteDifference
    method::M
end

"""
    ForwardDiffBackend{CS}

AD backend that uses forward mode with ForwardDiff.jl.

The type parameter `CS` denotes the chunk size of the differentiation algorithm. If it is
`Nothing`, then ForwardiffDiff uses a heuristic to set the chunk size based on the input.

See also: [ForwardDiff.jl: Configuring Chunk Size](https://juliadiff.org/ForwardDiff.jl/dev/user/advanced/#Configuring-Chunk-Size)

!!! note
    To be able to use this backend, you have to load ForwardDiff.
"""
struct ForwardDiffBackend{CS} <: AbstractForwardMode end

"""
    ReverseDiffBackend

AD backend that uses reverse mode with ReverseDiff.jl.

!!! note
    To be able to use this backend, you have to load ReverseDiff.
"""
struct ReverseDiffBackend <: AbstractReverseMode end

"""
    TrackerBackend

AD backend that uses reverse mode with Tracker.jl.

!!! note
    To be able to use this backend, you have to load Tracker.
"""
struct TrackerBackend <: AbstractReverseMode end


"""
    ReverseRuleConfigBackend

AD backend that uses reverse mode with any ChainRules-compatible reverse-mode AD package.

!!! note
    On Julia >= 1.9, you have to load ChainRulesCore (possibly implicitly by loading
    a ChainRules-compatible AD package) to be able to use this backend.
"""
struct ReverseRuleConfigBackend{RC} <: AbstractReverseMode
    ruleconfig::RC
end

# internal function for extracting the rule config
# falls back to returning the wrapped `ruleconfig` but can be specialized
# e.g., for Zygote to fix #69
ruleconfig(ba::ReverseRuleConfigBackend) = ba.ruleconfig

"""
    ZygoteBackend()

Create an AD backend that uses reverse mode with Zygote.jl.

It is a special case of [`ReverseRuleConfigBackend`](@ref).

!!! note
    To be able to use this backend, you have to load Zygote.
"""
function ZygoteBackend end

module AbstractDifferentiationForwardDiffExt

if isdefined(Base, :get_extension)
    import AbstractDifferentiation as AD
    using DiffResults: DiffResults
    using ForwardDiff: ForwardDiff
else
    import ..AbstractDifferentiation as AD
    using ..DiffResults: DiffResults
    using ..ForwardDiff: ForwardDiff
end

"""
    ForwardDiffBackend(; chunksize::Union{Val,Nothing}=nothing)

Create an AD backend that uses forward mode with ForwardDiff.jl.

If the `chunksize` of the differentiation algorithm is set to `nothing` (the default), then
ForwarddDiff uses a heuristic to set the chunk size based on the input. Alternatively, if
`chunksize=Val{N}()`, then the chunk size is set to `N`.

See also: [ForwardDiff.jl: Configuring Chunk Size](https://juliadiff.org/ForwardDiff.jl/dev/user/advanced/#Configuring-Chunk-Size)
"""
function AD.ForwardDiffBackend(; chunksize::Union{Val,Nothing}=nothing)
    return AD.ForwardDiffBackend{getchunksize(chunksize)}()
end

AD.@primitive function pushforward_function(ba::AD.ForwardDiffBackend, f, xs...)
    return function pushforward(vs)
        if length(xs) == 1
            v = vs isa Tuple ? only(vs) : vs
            return (ForwardDiff.derivative(h -> f(step_toward(xs[1], v, h)), 0),)
        else
            return ForwardDiff.derivative(h -> f(step_toward.(xs, vs, h)...), 0)
        end
    end
end

AD.primal_value(x::ForwardDiff.Dual) = ForwardDiff.value(x)
AD.primal_value(x::AbstractArray{<:ForwardDiff.Dual}) = ForwardDiff.value.(x)

# these implementations are more efficient than the fallbacks

function AD.derivative(::AD.ForwardDiffBackend, f, x::Real)
    return (ForwardDiff.derivative(f, x),)
end

function AD.gradient(ba::AD.ForwardDiffBackend, f, x::AbstractArray)
    cfg = ForwardDiff.GradientConfig(f, x, chunk(ba, x))
    return (ForwardDiff.gradient(f, x, cfg),)
end

function AD.jacobian(ba::AD.ForwardDiffBackend, f, x::AbstractArray)
    cfg = ForwardDiff.JacobianConfig(AD.asarray ∘ f, x, chunk(ba, x))
    return (ForwardDiff.jacobian(AD.asarray ∘ f, x, cfg),)
end
AD.jacobian(::AD.ForwardDiffBackend, f, x::Real) = (ForwardDiff.derivative(f, x),)

function AD.hessian(ba::AD.ForwardDiffBackend, f, x::AbstractArray)
    cfg = ForwardDiff.HessianConfig(f, x, chunk(ba, x))
    return (ForwardDiff.hessian(f, x, cfg),)
end

function AD.value_and_gradient(ba::AD.ForwardDiffBackend, f, x::AbstractArray)
    result = DiffResults.GradientResult(x)
    cfg = ForwardDiff.GradientConfig(f, x, chunk(ba, x))
    ForwardDiff.gradient!(result, f, x, cfg)
    return DiffResults.value(result), (DiffResults.derivative(result),)
end

function AD.value_and_hessian(ba::AD.ForwardDiffBackend, f, x)
    result = DiffResults.HessianResult(x)
    cfg = ForwardDiff.HessianConfig(f, result, x, chunk(ba, x))
    ForwardDiff.hessian!(result, f, x, cfg)
    return DiffResults.value(result), (DiffResults.hessian(result),)
end

@inline step_toward(x::Number, v::Number, h) = x + h * v
# support arrays and tuples
@noinline step_toward(x, v, h) = x .+ h .* v

getchunksize(::Nothing) = Nothing
getchunksize(::Val{N}) where {N} = N

chunk(::AD.ForwardDiffBackend{Nothing}, x) = ForwardDiff.Chunk(x)
chunk(::AD.ForwardDiffBackend{N}, _) where {N} = ForwardDiff.Chunk{N}()

end # module

using AbstractDifferentiation
using Test

@testset "AbstractDifferentiation.jl" begin
    include("test_utils.jl")
    include("defaults.jl")
    include("forwarddiff.jl")
    include("reversediff.jl")
    include("finitedifferences.jl")
    include("tracker.jl")
    include("ruleconfig.jl")
end

using AbstractDifferentiation
using Test, LinearAlgebra
using Random
Random.seed!(1234)

fder(x, y) = exp(y) * x + y * log(x)
dfderdx(x, y) = exp(y) + y * 1 / x
dfderdy(x, y) = exp(y) * x + log(x)
dfderdxdx(x, y) = -y / x^2

fgrad(x, y) = prod(x) + sum(y ./ (1:length(y)))
dfgraddx(x, y) = prod(x) ./ x
dfgraddy(x, y) = one(eltype(y)) ./ (1:length(y))
dfgraddxdx(x, y) = prod(x) ./ (x * x') - Diagonal(diag(prod(x) ./ (x * x')))
dfgraddydy(x, y) = zeros(length(y), length(y))

function fjac(x, y)
    return x + -3 * y + [y[2:end]; zero(y[end])] / 2# Bidiagonal(-ones(length(y)) * 3, ones(length(y) - 1) / 2, :U) * y
end
dfjacdx(x, y) = I(length(x))
dfjacdy(x, y) = Bidiagonal(-ones(length(y)) * 3, ones(length(y) - 1) / 2, :U)

# Jvp
jxvp(x, y, v) = dfjacdx(x, y) * v
jyvp(x, y, v) = dfjacdy(x, y) * v

# vJp
vJxp(x, y, v) = dfjacdx(x, y)' * v
vJyp(x, y, v) = dfjacdy(x, y)' * v

const xscalar = rand()
const yscalar = rand()

const xvec = rand(5)
const yvec = rand(5)

# to check if vectors get mutated
xvec2 = deepcopy(xvec)
yvec2 = deepcopy(yvec)

function test_higher_order_backend(backends...)
    ADbackends = AD.HigherOrderBackend(backends)
    @test backends[end] == AD.lowest(ADbackends)
    @test backends[end - 1] == AD.second_lowest(ADbackends)

    for i in length(backends):-1:1
        @test backends[i] == AD.lowest(ADbackends)
        ADbackends = AD.reduce_order(ADbackends)
    end
    return backends[1] == AD.reduce_order(ADbackends)
end

function test_derivatives(backend; multiple_inputs=true, test_types=true)
    # test with respect to analytical solution
    der_exact = (dfderdx(xscalar, yscalar), dfderdy(xscalar, yscalar))
    if multiple_inputs
        der1 = AD.derivative(backend, fder, xscalar, yscalar)
        @test minimum(isapprox.(der_exact, der1, rtol=1e-10))
        valscalar, der2 = AD.value_and_derivative(backend, fder, xscalar, yscalar)
        @test valscalar == fder(xscalar, yscalar)
        @test der2 .- der1 == (0, 0)
    end
    # test if single input (no tuple works)
    valscalara, dera = AD.value_and_derivative(backend, x -> fder(x, yscalar), xscalar)
    valscalarb, derb = AD.value_and_derivative(backend, y -> fder(xscalar, y), yscalar)
    if test_types
        @test valscalara isa Float64
        @test valscalarb isa Float64
        @test dera[1] isa Float64
        @test derb[1] isa Float64
    end
    @test fder(xscalar, yscalar) == valscalara
    @test fder(xscalar, yscalar) == valscalarb
    @test isapprox(dera[1], der_exact[1], rtol=1e-10)
    @test isapprox(derb[1], der_exact[2], rtol=1e-10)
end

function test_gradients(backend; multiple_inputs=true, test_types=true)
    # test with respect to analytical solution
    grad_exact = (dfgraddx(xvec, yvec), dfgraddy(xvec, yvec))
    if multiple_inputs
        grad1 = AD.gradient(backend, fgrad, xvec, yvec)
        @test minimum(isapprox.(grad_exact, grad1, rtol=1e-10))
        valscalar, grad2 = AD.value_and_gradient(backend, fgrad, xvec, yvec)
        if test_types
            @test valscalar isa Float64
            @test grad1[1] isa AbstractVector{Float64}
            @test grad1[2] isa AbstractVector{Float64}
            @test grad2[1] isa AbstractVector{Float64}
            @test grad2[2] isa AbstractVector{Float64}
        end
        @test valscalar == fgrad(xvec, yvec)
        @test norm.(grad2 .- grad1) == (0, 0)
    end
    # test if single input (no tuple works)
    valscalara, grada = AD.value_and_gradient(backend, x -> fgrad(x, yvec), xvec)
    valscalarb, gradb = AD.value_and_gradient(backend, y -> fgrad(xvec, y), yvec)
    if test_types
        @test valscalara isa Float64
        @test valscalarb isa Float64
        @test grada[1] isa AbstractVector{Float64}
        @test gradb[1] isa AbstractVector{Float64}
    end
    @test fgrad(xvec, yvec) == valscalara
    @test fgrad(xvec, yvec) == valscalarb
    @test isapprox(grada[1], grad_exact[1], rtol=1e-10)
    @test isapprox(gradb[1], grad_exact[2], rtol=1e-10)
    @test xvec == xvec2
    @test yvec == yvec2
end

function test_jacobians(backend; multiple_inputs=true, test_types=true)
    # test with respect to analytical solution
    jac_exact = (dfjacdx(xvec, yvec), dfjacdy(xvec, yvec))
    if multiple_inputs
        jac1 = AD.jacobian(backend, fjac, xvec, yvec)
        @test minimum(isapprox.(jac_exact, jac1, rtol=1e-10))
        valvec, jac2 = AD.value_and_jacobian(backend, fjac, xvec, yvec)
        if test_types
            @test valvec isa Vector{Float64}
            @test jac1[1] isa Matrix{Float64}
            @test jac1[2] isa Matrix{Float64}
            @test jac2[1] isa Matrix{Float64}
            @test jac2[2] isa Matrix{Float64}
        end
        @test valvec == fjac(xvec, yvec)
        @test norm.(jac2 .- jac1) == (0, 0)
    end

    # test if single input (no tuple works)
    valveca, jaca = AD.value_and_jacobian(backend, x -> fjac(x, yvec), xvec)
    valvecb, jacb = AD.value_and_jacobian(backend, y -> fjac(xvec, y), yvec)
    if test_types
        @test valveca isa Vector{Float64}
        @test valvecb isa Vector{Float64}
        @test jaca[1] isa Matrix{Float64}
        @test jacb[1] isa Matrix{Float64}
    end
    @test fjac(xvec, yvec) == valveca
    @test fjac(xvec, yvec) == valvecb
    @test isapprox(jaca[1], jac_exact[1], rtol=1e-10)
    @test isapprox(jacb[1], jac_exact[2], rtol=1e-10)
    @test xvec == xvec2
    @test yvec == yvec2
end

function test_second_derivatives(backend; test_types=true)
    # explicit test that AbstractDifferentiation throws an error
    # don't support tuple of second derivatives
    @test_throws ArgumentError AD.second_derivative(
        backend, x -> fder(x, yscalar), (xscalar, yscalar)
    )
    @test_throws MethodError AD.second_derivative(
        backend, x -> fder(x, yscalar), xscalar, yscalar
    )

    # test if single input (no tuple works)
    dder1 = AD.second_derivative(backend, x -> fder(x, yscalar), xscalar)
    if test_types
        @test only(dder1) isa Float64
    end
    @test dfderdxdx(xscalar, yscalar) ≈ only(dder1) atol = 1e-8
    valscalar, dder2 = AD.value_and_second_derivative(
        backend, x -> fder(x, yscalar), xscalar
    )
    if test_types
        @test valscalar isa Float64
        @test only(dder2) isa Float64
    end
    @test valscalar == fder(xscalar, yscalar)
    @test dder2 == dder1
    valscalar, der, dder3 = AD.value_derivative_and_second_derivative(
        backend, x -> fder(x, yscalar), xscalar
    )
    if test_types
        @test valscalar isa Float64
        @test only(der) isa Float64
        @test only(dder3) isa Float64
    end
    @test valscalar == fder(xscalar, yscalar)
    @test der == AD.derivative(backend, x -> fder(x, yscalar), xscalar)
    @test dder3 == dder1
end

function test_hessians(backend; multiple_inputs=false, test_types=true)
    if multiple_inputs
        # ... but 
        error("multiple_inputs=true is not supported.")
    else
        # explicit test that AbstractDifferentiation throws an error
        # don't support tuple of Hessians
        @test_throws ArgumentError AD.hessian(backend, fgrad, (xvec, yvec))
        @test_throws MethodError AD.hessian(backend, fgrad, xvec, yvec)
    end

    # @test dfgraddxdx(xvec,yvec) ≈ H1[1] atol=1e-10
    # @test dfgraddydy(xvec,yvec) ≈ H1[2] atol=1e-10

    # test if single input (no tuple works)
    fhess = x -> fgrad(x, yvec)
    hess1 = AD.hessian(backend, fhess, xvec)
    if test_types
        @test hess1[1] isa Matrix{Float64}
    end
    # test with respect to analytical solution
    @test dfgraddxdx(xvec, yvec) ≈ hess1[1] atol = 1e-10

    valscalar, hess2 = AD.value_and_hessian(backend, fhess, xvec)
    if test_types
        @test valscalar isa Float64
        @test hess2[1] isa Matrix{Float64}
    end
    @test valscalar == fgrad(xvec, yvec)
    @test norm.(hess2 .- hess1) == (0,)
    valscalar, grad, hess3 = AD.value_gradient_and_hessian(backend, fhess, xvec)
    if test_types
        @test valscalar isa Float64
        @test grad[1] isa AbstractVector{Float64}
        @test hess3[1] isa Matrix{Float64}
    end
    @test valscalar == fgrad(xvec, yvec)
    @test norm.(grad .- AD.gradient(backend, fhess, xvec)) == (0,)
    @test norm.(hess3 .- hess1) == (0,)

    @test xvec == xvec2
    @test yvec == yvec2
    fhess2 = x -> dfgraddx(x, yvec)
    hess4 = AD.jacobian(backend, fhess2, xvec)
    if test_types
        @test hess4[1] isa Matrix{Float64}
    end
    @test minimum(isapprox.(hess4, hess1, atol=1e-10))
end

function test_jvp(
    backend; multiple_inputs=true, vaugmented=false, rng=Random.GLOBAL_RNG, test_types=true
)
    v = (rand(rng, length(xvec)), rand(rng, length(yvec)))

    if multiple_inputs
        if vaugmented
            identity_like = AD.identity_matrix_like(v)
            vaug = map(identity_like) do identity_like_i
                identity_like_i .* v
            end

            pf1 = map(v -> AD.pushforward_function(backend, fjac, xvec, yvec)(v), vaug)
            ((valvec1, pf2x), (valvec2, pf2y)) = map(
                v -> AD.value_and_pushforward_function(backend, fjac, xvec, yvec)(v), vaug
            )
        else
            pf1 = AD.pushforward_function(backend, fjac, xvec, yvec)(v)
            valvec, pf2 = AD.value_and_pushforward_function(backend, fjac, xvec, yvec)(v)
            ((valvec1, pf2x), (valvec2, pf2y)) = (valvec, pf2[1]), (valvec, pf2[2])
        end

        if test_types
            @test valvec1 isa Vector{Float64}
            @test valvec2 isa Vector{Float64}
            @test pf1[1] isa Vector{Float64}
            @test pf1[2] isa Vector{Float64}
            @test pf2x isa Vector{Float64}
            @test pf2y isa Vector{Float64}
        end
        @test valvec1 == fjac(xvec, yvec)
        @test valvec2 == fjac(xvec, yvec)
        @test norm.((pf2x, pf2y) .- pf1) == (0, 0)
        # test with respect to analytical solution
        @test minimum(
            isapprox.(pf1, (jxvp(xvec, yvec, v[1]), jyvp(xvec, yvec, v[2])), atol=1e-10)
        )
        @test xvec == xvec2
        @test yvec == yvec2
    end

    valvec1, pf1 = AD.value_and_pushforward_function(backend, x -> fjac(x, yvec), xvec)(
        v[1]
    )
    valvec2, pf2 = AD.value_and_pushforward_function(backend, y -> fjac(xvec, y), yvec)(
        v[2]
    )

    if test_types
        @test valvec1 isa Vector{Float64}
        @test valvec2 isa Vector{Float64}
        @test pf1[1] isa Vector{Float64}
        @test pf2[1] isa Vector{Float64}
    end
    @test valvec1 == fjac(xvec, yvec)
    @test valvec2 == fjac(xvec, yvec)
    @test minimum(
        isapprox.(
            (pf1[1], pf2[1]), (jxvp(xvec, yvec, v[1]), jyvp(xvec, yvec, v[2])), atol=1e-10
        ),
    )
end

function test_j′vp(backend; multiple_inputs=true, rng=Random.GLOBAL_RNG, test_types=true)
    # test with respect to analytical solution
    w = rand(rng, length(fjac(xvec, yvec)))
    if multiple_inputs
        pb1 = AD.pullback_function(backend, fjac, xvec, yvec)(w)
        valvec, pbf2 = AD.value_and_pullback_function(backend, fjac, xvec, yvec)
        pb2 = pbf2(w)

        if test_types
            @test valvec isa Vector{Float64}
            @test pb1[1] isa AbstractVector{Float64}
            @test pb1[2] isa AbstractVector{Float64}
            @test pb2[1] isa AbstractVector{Float64}
            @test pb2[2] isa AbstractVector{Float64}
        end
        @test valvec == fjac(xvec, yvec)
        @test norm.(pb2 .- pb1) == (0, 0)
        @test minimum(
            isapprox.(pb1, (vJxp(xvec, yvec, w), vJyp(xvec, yvec, w)), atol=1e-10)
        )
        @test xvec == xvec2
        @test yvec == yvec2
    end

    valvec1, pbf1 = AD.value_and_pullback_function(backend, x -> fjac(x, yvec), xvec)
    pb1 = pbf1(w)
    valvec2, pbf2 = AD.value_and_pullback_function(backend, y -> fjac(xvec, y), yvec)
    pb2 = pbf2(w)
    if test_types
        @test valvec1 isa Vector{Float64}
        @test valvec2 isa Vector{Float64}
        @test pb1[1] isa AbstractVector{Float64}
        @test pb2[1] isa AbstractVector{Float64}
    end
    @test valvec1 == fjac(xvec, yvec)
    @test valvec2 == fjac(xvec, yvec)
    @test minimum(
        isapprox.((pb1[1], pb2[1]), (vJxp(xvec, yvec, w), vJyp(xvec, yvec, w)), atol=1e-10)
    )
end

function test_lazy_derivatives(backend; multiple_inputs=true)
    # single input function
    der1 = AD.derivative(backend, x -> fder(x, yscalar), xscalar)
    lazyder = AD.LazyDerivative(backend, x -> fder(x, yscalar), xscalar)

    # multiplication with scalar
    @test lazyder * yscalar == der1 .* yscalar
    @test lazyder * yscalar isa Tuple

    @test yscalar * lazyder == yscalar .* der1
    @test yscalar * lazyder isa Tuple

    # multiplication with array
    @test lazyder * yvec == (der1 .* yvec,)
    @test lazyder * yvec isa Tuple

    @test yvec * lazyder == (yvec .* der1,)
    @test yvec * lazyder isa Tuple

    # multiplication with tuple
    @test lazyder * (yscalar,) == lazyder * yscalar
    @test lazyder * (yvec,) == lazyder * yvec

    @test (yscalar,) * lazyder == yscalar * lazyder
    @test (yvec,) * lazyder == yvec * lazyder

    # two input function
    if multiple_inputs
        der1 = AD.derivative(backend, fder, xscalar, yscalar)
        lazyder = AD.LazyDerivative(backend, fder, (xscalar, yscalar))

        # multiplication with scalar
        @test lazyder * yscalar == der1 .* yscalar
        @test lazyder * yscalar isa Tuple

        @test yscalar * lazyder == yscalar .* der1
        @test yscalar * lazyder isa Tuple

        # multiplication with array
        @test lazyder * yvec == (der1[1] * yvec, der1[2] * yvec)
        @test lazyder * yvec isa Tuple

        @test yvec * lazyder == (yvec * der1[1], yvec * der1[2])
        @test lazyder * yvec isa Tuple

        # multiplication with tuple
        @test_throws AssertionError lazyder * (yscalar,)
        @test_throws AssertionError lazyder * (yvec,)

        @test_throws AssertionError (yscalar,) * lazyder
        @test_throws AssertionError (yvec,) * lazyder
    end
end

function test_lazy_gradients(backend; multiple_inputs=true)
    # single input function
    grad1 = AD.gradient(backend, x -> fgrad(x, yvec), xvec)
    lazygrad = AD.LazyGradient(backend, x -> fgrad(x, yvec), xvec)

    # multiplication with scalar
    @test norm.(lazygrad * yscalar .- grad1 .* yscalar) == (0,)
    @test lazygrad * yscalar isa Tuple

    @test norm.(yscalar * lazygrad .- yscalar .* grad1) == (0,)
    @test yscalar * lazygrad isa Tuple

    # multiplication with tuple
    @test lazygrad * (yscalar,) == lazygrad * yscalar
    @test (yscalar,) * lazygrad == yscalar * lazygrad

    # two input function
    if multiple_inputs
        grad1 = AD.gradient(backend, fgrad, xvec, yvec)
        lazygrad = AD.LazyGradient(backend, fgrad, (xvec, yvec))

        # multiplication with scalar
        @test norm.(lazygrad * yscalar .- grad1 .* yscalar) == (0, 0)
        @test lazygrad * yscalar isa Tuple

        @test norm.(yscalar * lazygrad .- yscalar .* grad1) == (0, 0)
        @test yscalar * lazygrad isa Tuple

        # multiplication with tuple
        @test_throws AssertionError lazygrad * (yscalar,) == lazygrad * yscalar
        @test_throws AssertionError (yscalar,) * lazygrad == yscalar * lazygrad
    end
end

function test_lazy_jacobians(
    backend; multiple_inputs=true, vaugmented=false, rng=Random.GLOBAL_RNG
)
    # single input function
    jac1 = AD.jacobian(backend, x -> fjac(x, yvec), xvec)
    lazyjac = AD.LazyJacobian(backend, x -> fjac(x, yvec), xvec)

    # multiplication with scalar
    @test norm.(lazyjac * yscalar .- jac1 .* yscalar) == (0,)
    @test lazyjac * yscalar isa Tuple

    @test norm.(yscalar * lazyjac .- yscalar .* jac1) == (0,)
    @test yscalar * lazyjac isa Tuple

    w = rand(rng, length(fjac(xvec, yvec)))
    v = (rand(rng, length(xvec)), rand(rng, length(xvec)))

    # vjp
    pb1 = (vJxp(xvec, yvec, w),)
    res = w' * lazyjac
    @test minimum(isapprox.(pb1, res, atol=1e-10))
    @test res isa Tuple

    # jvp
    pf1 = (jxvp(xvec, yvec, v[1]),)
    res = lazyjac * v[1]
    @test minimum(isapprox.(pf1, res, atol=1e-10))
    @test res isa Tuple

    # two input function
    if multiple_inputs
        jac1 = AD.jacobian(backend, fjac, xvec, yvec)
        lazyjac = AD.LazyJacobian(backend, fjac, (xvec, yvec))

        # multiplication with scalar
        @test norm.(lazyjac * yscalar .- jac1 .* yscalar) == (0, 0)
        @test lazyjac * yscalar isa Tuple

        @test norm.(yscalar * lazyjac .- yscalar .* jac1) == (0, 0)
        @test yscalar * lazyjac isa Tuple

        # vjp
        pb1 = (vJxp(xvec, yvec, w), vJyp(xvec, yvec, w))
        res = w'lazyjac
        @test minimum(isapprox.(pb1, res, atol=1e-10))
        @test res isa Tuple

        # jvp
        pf1 = (jxvp(xvec, yvec, v[1]), jyvp(xvec, yvec, v[2]))

        if vaugmented
            identity_like = AD.identity_matrix_like(v)
            vaug = map(identity_like) do identity_like_i
                identity_like_i .* v
            end

            res = map(v -> (lazyjac * v)[1], vaug)
        else
            res = lazyjac * v
        end
        @test minimum(isapprox.(pf1, res, atol=1e-10))
        @test res isa Tuple
    end
end

function test_lazy_hessians(backend; multiple_inputs=true, rng=Random.GLOBAL_RNG)
    # fdm_backend not used here yet..
    # single input function
    fhess = x -> fgrad(x, yvec)
    hess1 = (dfgraddxdx(xvec, yvec),)
    lazyhess = AD.LazyHessian(backend, fhess, xvec)

    # multiplication with scalar
    @test minimum(isapprox.(lazyhess * yscalar, hess1 .* yscalar, atol=1e-10))
    @test lazyhess * yscalar isa Tuple

    # multiplication with scalar
    @test minimum(isapprox.(yscalar * lazyhess, yscalar .* hess1, atol=1e-10))
    @test yscalar * lazyhess isa Tuple

    w = rand(rng, length(xvec))
    v = rand(rng, length(xvec))

    # Hvp
    Hv = map(h -> h * v, hess1)
    res = lazyhess * v
    @test minimum(isapprox.(Hv, res, atol=1e-10))
    @test res isa Tuple

    # H′vp
    wH = map(h -> h' * w, hess1)
    res = w' * lazyhess
    @test minimum(isapprox.(wH, res, atol=1e-10))
    @test res isa Tuple
end

module AbstractDifferentiationReverseDiffExt

if isdefined(Base, :get_extension)
    import AbstractDifferentiation as AD
    using DiffResults: DiffResults
    using ReverseDiff: ReverseDiff
else
    import ..AbstractDifferentiation as AD
    using ..DiffResults: DiffResults
    using ..ReverseDiff: ReverseDiff
end

AD.primal_value(x::ReverseDiff.TrackedReal) = ReverseDiff.value(x)
AD.primal_value(x::AbstractArray{<:ReverseDiff.TrackedReal}) = ReverseDiff.value.(x)
AD.primal_value(x::ReverseDiff.TrackedArray) = ReverseDiff.value(x)

AD.@primitive function jacobian(ba::AD.ReverseDiffBackend, f, xs...)
    xs_arr = map(AD.asarray, xs)
    tape = ReverseDiff.JacobianTape(xs_arr) do (xs_arr...)
        xs_new = map(xs, xs_arr) do x, x_arr
            return x isa Number ? only(x_arr) : x_arr
        end
        return AD.asarray(f(xs_new...))
    end
    results = ReverseDiff.jacobian!(tape, xs_arr)
    return map(xs, results) do x, result
        return x isa Number ? vec(result) : result
    end
end
function AD.jacobian(::AD.ReverseDiffBackend, f, xs::AbstractArray...)
    return ReverseDiff.jacobian(AD.asarray ∘ f, xs)
end

function AD.derivative(::AD.ReverseDiffBackend, f, xs::Number...)
    tape = ReverseDiff.InstructionTape()
    xs_tracked = ReverseDiff.TrackedReal.(xs, zero.(xs), Ref(tape))
    y_tracked = f(xs_tracked...)
    ReverseDiff.seed!(y_tracked)
    ReverseDiff.reverse_pass!(tape)
    return ReverseDiff.deriv.(xs_tracked)
end

function AD.gradient(::AD.ReverseDiffBackend, f, xs::AbstractArray...)
    return ReverseDiff.gradient(f, xs)
end

function AD.hessian(::AD.ReverseDiffBackend, f, x::AbstractArray)
    return (ReverseDiff.hessian(f, x),)
end

function AD.value_and_gradient(::AD.ReverseDiffBackend, f, x::AbstractArray)
    result = DiffResults.GradientResult(x)
    cfg = ReverseDiff.GradientConfig(x)
    ReverseDiff.gradient!(result, f, x, cfg)
    return DiffResults.value(result), (DiffResults.derivative(result),)
end

function AD.value_and_hessian(::AD.ReverseDiffBackend, f, x)
    result = DiffResults.HessianResult(x)
    cfg = ReverseDiff.HessianConfig(result, x)
    ReverseDiff.hessian!(result, f, x, cfg)
    return DiffResults.value(result), (DiffResults.hessian(result),)
end

end # module

using AbstractDifferentiation
using Test
using FiniteDifferences

@testset "FiniteDifferencesBackend" begin
    method = FiniteDifferences.central_fdm(6, 1)
    # `central_fdm(5, 1)` is not type-inferrable, so only check inferrability
    # with user-specified method
    backends = [
        AD.FiniteDifferencesBackend(), @inferred(AD.FiniteDifferencesBackend(method))
    ]
    @test backends[2].method === method

    @testset for backend in backends
        @testset "Derivative" begin
            test_derivatives(backend)
        end
        @testset "Gradient" begin
            test_gradients(backend)
        end
        @testset "Jacobian" begin
            test_jacobians(backend)
        end
        @testset "Second derivative" begin
            test_second_derivatives(backend)
        end
        @testset "Hessian" begin
            test_hessians(backend)
        end
        @testset "jvp" begin
            test_jvp(backend; vaugmented=true)
        end
        @testset "j′vp" begin
            test_j′vp(backend)
        end
        @testset "Lazy Derivative" begin
            test_lazy_derivatives(backend)
        end
        @testset "Lazy Gradient" begin
            test_lazy_gradients(backend)
        end
        @testset "Lazy Jacobian" begin
            test_lazy_jacobians(backend; vaugmented=true)
        end
        @testset "Lazy Hessian" begin
            test_lazy_hessians(backend)
        end
    end
end

module AbstractDifferentiation

using LinearAlgebra, ExprTools

abstract type AbstractBackend end
abstract type AbstractFiniteDifference <: AbstractBackend end
abstract type AbstractForwardMode <: AbstractBackend end
abstract type AbstractReverseMode <: AbstractBackend end

"""
    AD.HigherOrderBackend{B}

Let `ab_f` be a forward-mode automatic differentiation backend and let `ab_r` be a reverse-mode automatic differentiation backend.
To construct a higher order backend for doing forward-over-reverse-mode automatic differentiation, use `AD.HigherOrderBackend((ab_f, ab_r))`.
To construct a higher order backend for doing reverse-over-forward-mode automatic differentiation, use `AD.HigherOrderBackend((ab_r, ab_f))`.

# Fields

- `backends::B`
"""
struct HigherOrderBackend{B} <: AbstractBackend
    backends::B
end

reduce_order(b::AbstractBackend) = b

function reduce_order(b::HigherOrderBackend)
    if length(b.backends) == 1
        return lowest(b) # prevent zero tuple and subsequent error when reducing over HigherOrderBackend
    else
        return HigherOrderBackend(reverse(Base.tail(reverse(b.backends))))
    end
end

lowest(b::AbstractBackend) = b
lowest(b::HigherOrderBackend) = b.backends[end]

second_lowest(b::AbstractBackend) = b
second_lowest(b::HigherOrderBackend) = lowest(reduce_order(b))

# If the primal value is in y, extract it.
# Otherwise, re-compute it, e.g. in finite diff.
primal_value(::AbstractFiniteDifference, ::Any, f, xs) = f(xs...)
primal_value(::AbstractBackend, ys, ::Any, ::Any) = primal_value(ys)
primal_value(x::Tuple) = map(primal_value, x)
primal_value(x) = x

"""
    AD.derivative(ab::AD.AbstractBackend, f, xs::Number...)

Compute the derivatives of `f` with respect to the numbers `xs` using the backend `ab`.

The function returns a `Tuple` of derivatives, one for each element in `xs`.
"""
function derivative(ab::AbstractBackend, f, xs::Number...)
    der = getindex.(jacobian(lowest(ab), f, xs...), 1)
    if der isa Tuple
        return der
    else
        return (der,)
    end
end

"""
    AD.gradient(ab::AD.AbstractBackend, f, xs...)

Compute the gradients of `f` with respect to the inputs `xs` using the backend `ab`.

The function returns a `Tuple` of gradients, one for each element in `xs`.
"""
function gradient(ab::AbstractBackend, f, xs...)
    return reshape.(adjoint.(jacobian(lowest(ab), f, xs...)), size.(xs))
end

"""
    AD.jacobian(ab::AD.AbstractBackend, f, xs...)

Compute the Jacobians of `f` with respect to the inputs `xs` using the backend `ab`.

The function returns a `Tuple` of Jacobians, one for each element in `xs`.
"""
function jacobian(ab::AbstractBackend, f, xs...) end

function jacobian(ab::HigherOrderBackend, f, xs...)
    return jacobian(lowest(ab), f, xs...)
end

"""
    AD.second_derivative(ab::AD.AbstractBackend, f, x)

Compute the second derivative of `f` with respect to the input `x` using the backend `ab`.

The function returns a single value because `second_derivative` currently only supports a single input.
"""
function second_derivative(ab::AbstractBackend, f, x)
    if x isa Tuple
        # only support computation of second derivative for functions with single input argument
        x = only(x)
    end
    return derivative(second_lowest(ab), x -> begin
        d = derivative(lowest(ab), f, x)
        return d[1] # derivative returns a tuple
    end, x)
end

"""
    AD.hessian(ab::AD.AbstractBackend, f, x)

Compute the Hessian of `f` wrt the input `x` using the backend `ab`.

The function returns a single matrix because `hessian` currently only supports a single input.
"""
function hessian(ab::AbstractBackend, f, x)
    if x isa Tuple
        # only support computation of Hessian for functions with single input argument
        x = only(x)
    end
    return jacobian(second_lowest(ab), x -> begin
        gradient(lowest(ab), f, x)[1] # gradient returns a tuple
    end, x)
end

"""
    AD.value_and_derivative(ab::AD.AbstractBackend, f, xs::Number...)

Return the tuple `(v, ds)` of the function value `v = f(xs...)` and the derivatives `ds = AD.derivative(ab, f, xs...)`.

See also [`AbstractDifferentiation.derivative`](@ref).
"""
function value_and_derivative(ab::AbstractBackend, f, xs::Number...)
    value, jacs = value_and_jacobian(lowest(ab), f, xs...)
    return value[1], getindex.(jacs, 1)
end

"""
    AD.value_and_gradient(ab::AD.AbstractBackend, f, xs...)

Return the tuple `(v, gs)` of the function value `v = f(xs...)` and the gradients `gs = AD.gradient(ab, f, xs...)`.
    
See also [`AbstractDifferentiation.gradient`](@ref).
"""
function value_and_gradient(ab::AbstractBackend, f, xs...)
    value, jacs = value_and_jacobian(lowest(ab), f, xs...)
    return value, reshape.(adjoint.(jacs), size.(xs))
end

"""
    AD.value_and_jacobian(ab::AD.AbstractBackend, f, xs...)

Return the tuple `(v, Js)` of the function value `v = f(xs...)` and the Jacobians `Js = AD.jacobian(ab, f, xs...)`.
    
See also [`AbstractDifferentiation.jacobian`](@ref).
"""
function value_and_jacobian(ab::AbstractBackend, f, xs...)
    value = f(xs...)
    jacs = jacobian(lowest(ab), f, xs...)
    return value, jacs
end

"""
    AD.value_and_second_derivative(ab::AD.AbstractBackend, f, x)

Return the tuple `(v, d2)` of the function value `v = f(x)` and the second derivative `d2 = AD.second_derivative(ab, f, x)`.

See also [`AbstractDifferentiation.second_derivative`](@ref)
"""
function value_and_second_derivative(ab::AbstractBackend, f, x)
    return f(x), second_derivative(ab, f, x)
end

"""
    AD.value_and_hessian(ab::AD.AbstractBackend, f, x)

Return the tuple `(v, H)` of the function value `v = f(x)` and the Hessian `H = AD.hessian(ab, f, x)`.

See also [`AbstractDifferentiation.hessian`](@ref). 
"""
function value_and_hessian(ab::AbstractBackend, f, x)
    if x isa Tuple
        # only support computation of Hessian for functions with single input argument
        x = only(x)
    end

    value = f(x)
    hess = jacobian(second_lowest(ab), _x -> begin
        g = gradient(lowest(ab), f, _x)
        return g[1] # gradient returns a tuple
    end, x)

    return value, hess
end

"""
    AD.value_derivative_and_second_derivative(ab::AD.AbstractBackend, f, x)

Return the tuple `(v, d, d2)` of the function value `v = f(x)`, the first derivative `d = AD.derivative(ab, f, x)`, and the second derivative `d2 = AD.second_derivative(ab, f, x)`.
"""
function value_derivative_and_second_derivative(ab::AbstractBackend, f, x)
    if x isa Tuple
        # only support computation of Hessian for functions with single input argument
        x = only(x)
    end

    value = f(x)
    deriv, secondderiv = value_and_derivative(
        second_lowest(ab), _x -> begin
            d = derivative(lowest(ab), f, _x)
            return d[1] # derivative returns a tuple
        end, x
    )

    return value, (deriv,), secondderiv
end

"""
    AD.value_gradient_and_hessian(ab::AD.AbstractBackend, f, x)
    
Return the tuple `(v, g, H)` of the function value `v = f(x)`, the gradient `g = AD.gradient(ab, f, x)`, and the Hessian `H = AD.hessian(ab, f, x)`.

See also [`AbstractDifferentiation.gradient`](@ref) and [`AbstractDifferentiation.hessian`](@ref).
"""
function value_gradient_and_hessian(ab::AbstractBackend, f, x)
    if x isa Tuple
        # only support computation of Hessian for functions with single input argument
        x = only(x)
    end

    value = f(x)
    grads, hess = value_and_jacobian(
        second_lowest(ab), _x -> begin
            g = gradient(lowest(ab), f, _x)
            return g[1] # gradient returns a tuple
        end, x
    )

    return value, (grads,), hess
end

"""
    AD.pushforward_function(ab::AD.AbstractBackend, f, xs...)
    
Return the pushforward function `pff` of the function `f` at the inputs `xs` using backend `ab`. 
    
The pushfoward function `pff` accepts as input a `Tuple` of tangents, one for each element in `xs`.
If `xs` consists of a single element, `pff` can also accept a single tangent instead of a 1-tuple.
"""
function pushforward_function(ab::AbstractBackend, f, xs...)
    function pff(ds)
        function pff_aux(xds...)
            if ds isa Tuple
                @assert length(xs) == length(ds)
                newxs = xs .+ ds .* xds
                return f(newxs...)
            else
                newx = only(xs) + ds * only(xds)
                return f(newx)
            end
        end
        return jacobian(lowest(ab), pff_aux, _zero.(xs, ds)...)
    end
    return pff
end

"""
    AD.value_and_pushforward_function(ab::AD.AbstractBackend, f, xs...)
    
Return a single function `vpff` which, given tangents `ts`, computes the tuple `(v, p) = vpff(ts)` composed of
    
- the function value `v = f(xs...)`
- the pushforward value `p = pff(ts)` given by the pushforward function `pff = AD.pushforward_function(ab, f, xs...)` applied to `ts`.

See also [`AbstractDifferentiation.pushforward_function`](@ref).

!!! warning
    This name should be understood as "(value and pushforward) function", and thus is not aligned with the reverse mode counterpart [`AbstractDifferentiation.value_and_pullback_function`](@ref).
"""
function value_and_pushforward_function(ab::AbstractBackend, f, xs...)
    n = length(xs)
    value = f(xs...)
    pff = pushforward_function(lowest(ab), f, xs...)

    function vpff(ds)
        if !(ds isa Tuple)
            ds = (ds,)
        end
        @assert length(ds) == n
        return value, pff(ds)
    end
    return vpff
end

_zero(::Number, d::Number) = zero(d)
_zero(::Number, d::AbstractVector) = zero(d)
_zero(::AbstractVector, d::AbstractVector) = zero(eltype(d))
_zero(::AbstractVector, d::AbstractMatrix) = zero(similar(d, size(d, 2)))
_zero(::AbstractMatrix, d::AbstractMatrix) = zero(d)
_zero(::Any, d::Any) = zero(d)

@inline _dot(x, y) = dot(x, y)
@inline function _dot(x::AbstractVector, y::UniformScaling)
    return @inbounds dot(only(x), y.λ)
end
@inline function _dot(x::AbstractVector, y::AbstractMatrix)
    @assert size(y, 2) == 1
    return dot(x, y)
end

"""
    AD.pullback_function(ab::AD.AbstractBackend, f, xs...)

Return the pullback function `pbf` of the function `f` at the inputs `xs` using backend `ab`. 
    
The pullback function `pbf` accepts as input a `Tuple` of cotangents, one for each output of `f`.
If `f` has a single output, `pbf` can also accept a single input instead of a 1-tuple.
"""
function pullback_function(ab::AbstractBackend, f, xs...)
    _, pbf = value_and_pullback_function(ab, f, xs...)
    return pbf
end

"""
    AD.value_and_pullback_function(ab::AD.AbstractBackend, f, xs...)

Return a tuple `(v, pbf)` of the function value `v = f(xs...)` and the pullback function `pbf = AD.pullback_function(ab, f, xs...)`.

See also [`AbstractDifferentiation.pullback_function`](@ref).

!!! warning
    This name should be understood as "value and (pullback function)", and thus is not aligned with the forward mode counterpart [`AbstractDifferentiation.value_and_pushforward_function`](@ref).
"""
function value_and_pullback_function(ab::AbstractBackend, f, xs...)
    value = f(xs...)
    function pbf(ws)
        function pbf_aux(_xs...)
            vs = f(_xs...)
            if ws isa Tuple
                @assert length(vs) == length(ws)
                return sum(Base.splat(_dot), zip(ws, vs))
            else
                return _dot(vs, ws)
            end
        end
        return gradient(lowest(ab), pbf_aux, xs...)
    end
    return value, pbf
end

struct LazyDerivative{B,F,X}
    backend::B
    f::F
    xs::X
end

function Base.:*(d::LazyDerivative, y)
    return derivative(d.backend, d.f, d.xs...) * y
end

function Base.:*(y, d::LazyDerivative)
    return y * derivative(d.backend, d.f, d.xs...)
end

function Base.:*(d::LazyDerivative, y::Union{Number,Tuple})
    if y isa Tuple && d.xs isa Tuple
        @assert length(y) == length(d.xs)
    end
    return derivative(d.backend, d.f, d.xs...) .* y
end

function Base.:*(y::Union{Number,Tuple}, d::LazyDerivative)
    if y isa Tuple && d.xs isa Tuple
        @assert length(y) == length(d.xs)
    end
    return y .* derivative(d.backend, d.f, d.xs...)
end

function Base.:*(d::LazyDerivative, y::AbstractArray)
    return map((d) -> d * y, derivative(d.backend, d.f, d.xs...))
end

function Base.:*(y::AbstractArray, d::LazyDerivative)
    return map((d) -> y * d, derivative(d.backend, d.f, d.xs...))
end

struct LazyGradient{B,F,X}
    backend::B
    f::F
    xs::X
end

Base.:*(d::LazyGradient, y) = gradient(d.backend, d.f, d.xs...) * y
Base.:*(y, d::LazyGradient) = y * gradient(d.backend, d.f, d.xs...)

function Base.:*(d::LazyGradient, y::Union{Number,Tuple})
    if y isa Tuple && d.xs isa Tuple
        @assert length(y) == length(d.xs)
    end
    if d.xs isa Tuple
        return gradient(d.backend, d.f, d.xs...) .* y
    else
        return gradient(d.backend, d.f, d.xs) .* y
    end
end

function Base.:*(y::Union{Number,Tuple}, d::LazyGradient)
    if y isa Tuple && d.xs isa Tuple
        @assert length(y) == length(d.xs)
    end
    if d.xs isa Tuple
        return y .* gradient(d.backend, d.f, d.xs...)
    else
        return y .* gradient(d.backend, d.f, d.xs)
    end
end

struct LazyJacobian{B,F,X}
    backend::B
    f::F
    xs::X
end

function Base.:*(d::LazyJacobian, ys)
    if !(ys isa Tuple)
        ys = (ys,)
    end
    if d.xs isa Tuple
        vjp = pushforward_function(d.backend, d.f, d.xs...)(ys)
    else
        vjp = pushforward_function(d.backend, d.f, d.xs)(ys)
    end
    if vjp isa Tuple
        return vjp
    else
        return (vjp,)
    end
end

function Base.:*(ys, d::LazyJacobian)
    if ys isa Tuple
        ya = adjoint.(ys)
    else
        ya = adjoint(ys)
    end
    if d.xs isa Tuple
        return pullback_function(d.backend, d.f, d.xs...)(ya)
    else
        return pullback_function(d.backend, d.f, d.xs)(ya)
    end
end

function Base.:*(d::LazyJacobian, ys::Number)
    if d.xs isa Tuple
        return jacobian(d.backend, d.f, d.xs...) .* ys
    else
        return jacobian(d.backend, d.f, d.xs) .* ys
    end
end

function Base.:*(ys::Number, d::LazyJacobian)
    if d.xs isa Tuple
        return jacobian(d.backend, d.f, d.xs...) .* ys
    else
        return jacobian(d.backend, d.f, d.xs) .* ys
    end
end

struct LazyHessian{B,F,X}
    backend::B
    f::F
    xs::X
end

function Base.:*(d::LazyHessian, ys)
    if !(ys isa Tuple)
        ys = (ys,)
    end

    if d.xs isa Tuple
        res = pushforward_function(
            second_lowest(d.backend),
            (xs...,) -> gradient(lowest(d.backend), d.f, xs...)[1],
            d.xs...,
        )(
            ys
        )  # [1] because gradient returns a tuple
    else
        res = pushforward_function(
            second_lowest(d.backend), (xs,) -> gradient(lowest(d.backend), d.f, xs)[1], d.xs
        )(
            ys
        )  # gradient returns a tuple
    end
    if res isa Tuple
        return res
    else
        return (res,)
    end
end

function Base.:*(ys, d::LazyHessian)
    if ys isa Tuple
        ya = adjoint.(ys)
    else
        ya = adjoint(ys)
    end
    if d.xs isa Tuple
        return pullback_function(
            second_lowest(d.backend),
            (xs...,) -> gradient(lowest(d.backend), d.f, xs...),
            d.xs...,
        )(
            ya
        )
    else
        return pullback_function(
            second_lowest(d.backend), (xs,) -> gradient(lowest(d.backend), d.f, xs)[1], d.xs
        )(
            ya
        )
    end
end

function Base.:*(d::LazyHessian, ys::Number)
    if d.xs isa Tuple
        return hessian(d.backend, d.f, d.xs...) .* ys
    else
        return hessian(d.backend, d.f, d.xs) .* ys
    end
end

function Base.:*(ys::Number, d::LazyHessian)
    if d.xs isa Tuple
        return ys .* hessian(d.backend, d.f, d.xs...)
    else
        return ys .* hessian(d.backend, d.f, d.xs)
    end
end

"""
    AD.lazy_derivative(ab::AbstractBackend, f, xs::Number...)
    
Return an operator `ld` for multiplying by the derivative of `f` at `xs`.
    
You can apply the operator by multiplication e.g. `ld * y` where `y` is a number if `f` has a single input, a tuple of the same length as `xs` if `f` has multiple inputs, or an array of numbers/tuples.
"""
function lazy_derivative(ab::AbstractBackend, f, xs::Number...)
    return LazyDerivative(ab, f, xs)
end

"""
    AD.lazy_gradient(ab::AbstractBackend, f, xs...)
    
Return an operator `lg` for multiplying by the gradient of `f` at `xs`.
    
You can apply the operator by multiplication e.g. `lg * y` where `y` is a number if `f` has a single input or a tuple of the same length as `xs` if `f` has multiple inputs.
"""
function lazy_gradient(ab::AbstractBackend, f, xs...)
    return LazyGradient(ab, f, xs)
end

"""
    AD.lazy_hessian(ab::AbstractBackend, f, x)
    
Return an operator `lh` for multiplying by the Hessian of the scalar-valued function `f` at `x`.
    
You can apply the operator by multiplication e.g. `lh * y` or `y' * lh` where `y` is a number or a vector of the appropriate length.
"""
function lazy_hessian(ab::AbstractBackend, f, xs...)
    return LazyHessian(ab, f, xs)
end

"""
    AD.lazy_jacobian(ab::AbstractBackend, f, xs...)
    
Return an operator `lj` for multiplying by the Jacobian of `f` at `xs`.
    
You can apply the operator by multiplication e.g. `lj * y` or `y' * lj` where `y` is a number, vector or tuple of numbers and/or vectors. 
If `f` has multiple inputs, `y` in `lj * y` should be a tuple.
If `f` has multiple outputs, `y` in `y' * lj` should be a tuple.
Otherwise, it should be a scalar or a vector of the appropriate length.
"""
function lazy_jacobian(ab::AbstractBackend, f, xs...)
    return LazyJacobian(ab, f, xs)
end

struct D{B,F}
    backend::B
    f::F
end

D(b::AbstractBackend, d::D) = H(HigherOrderBackend((b, d.b)), d.f)
D(d::D) = H(HigherOrderBackend((d.backend, d.backend)), d.f)

function (d::D)(xs...; lazy=true)
    if lazy
        return lazy_jacobian(d.ab, d.f, xs...)
    else
        return jacobian(d.ab, d.f, xs...)
    end
end

struct H{B,F}
    backend::B
    f::F
end

function (h::H)(xs...; lazy=true)
    if lazy
        return lazy_hessian(h.ab, h.f, xs...)
    else
        return hessian(h.ab, h.f, xs...)
    end
end

macro primitive(expr)
    fdef = ExprTools.splitdef(expr)
    name = fdef[:name]
    if name == :pushforward_function
        return esc(define_pushforward_function_and_friends(fdef))
    elseif name == :value_and_pullback_function
        return esc(define_value_and_pullback_function_and_friends(fdef))
    else
        throw("Unsupported AD primitive.")
    end
end

function define_pushforward_function_and_friends(fdef)
    fdef[:name] = :($(AbstractDifferentiation).pushforward_function)
    args = fdef[:args]
    funcs = quote
        $(ExprTools.combinedef(fdef))
        function $(AbstractDifferentiation).jacobian($(args...))
            identity_like = $(identity_matrix_like)($(args[3:end]...))
            pff = $(pushforward_function)($(args...))
            if eltype(identity_like) <: Tuple{Vararg{Union{AbstractMatrix,Number}}}
                return map(identity_like) do identity_like_i
                    return mapreduce(hcat, $(_eachcol).(identity_like_i)...) do (cols...)
                        pff(cols)
                    end
                end
            elseif eltype(identity_like) <: AbstractMatrix
                # needed for the computation of the Hessian and Jacobian
                ret = hcat.(mapslices(identity_like[1]; dims=1) do cols
                    # cols loop over basis states   
                    pf = pff((cols,))
                    if typeof(pf) <: AbstractVector
                        # to make the hcat. work / get correct matrix-like, non-flat output dimension
                        return (pf,)
                    else
                        return pf
                    end
                end...)
                return ret isa Tuple ? ret : (ret,)

            else
                return pff(identity_like)
            end
        end
    end
    return funcs
end

function define_value_and_pullback_function_and_friends(fdef)
    fdef[:name] = :($(AbstractDifferentiation).value_and_pullback_function)
    args = fdef[:args]
    funcs = quote
        $(ExprTools.combinedef(fdef))
        function $(AbstractDifferentiation).jacobian($(args...))
            value, pbf = $(value_and_pullback_function)($(args...))
            identity_like = $(identity_matrix_like)(value)
            if eltype(identity_like) <: Tuple{Vararg{AbstractMatrix}}
                return map(identity_like) do identity_like_i
                    return mapreduce(vcat, $(_eachcol).(identity_like_i)...) do (cols...)
                        pbf(cols)'
                    end
                end
            elseif eltype(identity_like) <: AbstractMatrix
                # needed for Hessian computation:
                # value is a (grad,). Then, identity_like is a (matrix,).
                # cols loops over columns of the matrix  
                return vcat.(mapslices(identity_like[1]; dims=1) do cols
                    adjoint.(pbf((cols,)))
                end...)
            else
                return adjoint.(pbf(identity_like))
            end
        end
    end
    return funcs
end

_eachcol(a::Number) = (a,)
_eachcol(a) = eachcol(a)

function identity_matrix_like(x)
    throw("The function `identity_matrix_like` is not defined for the type $(typeof(x)).")
end

function identity_matrix_like(x::AbstractVector)
    return (Matrix{eltype(x)}(I, length(x), length(x)),)
end

function identity_matrix_like(x::Number)
    return (one(x),)
end

identity_matrix_like(x::Tuple) = identity_matrix_like(x...)

@generated function identity_matrix_like(x...)
    expr = :(())
    for i in 1:length(x)
        push!(expr.args, :(()))
        for j in 1:(i - 1)
            push!(expr.args[i].args, :((zero_matrix_like(x[$j])[1])))
        end
        push!(expr.args[i].args, :((identity_matrix_like(x[$i]))[1]))
        for j in (i + 1):length(x)
            push!(expr.args[i].args, :(zero_matrix_like(x[$j])[1]))
        end
    end
    return expr
end

zero_matrix_like(x::Tuple) = zero_matrix_like(x...)
zero_matrix_like(x...) = map(zero_matrix_like, x)
zero_matrix_like(x::AbstractVector) = (zero(similar(x, length(x), length(x))),)
zero_matrix_like(x::Number) = (zero(x),)

function zero_matrix_like(x)
    throw("The function `zero_matrix_like` is not defined for the type $(typeof(x)).")
end

@inline asarray(x) = [x]
@inline asarray(x::AbstractArray) = x

include("backends.jl")

# TODO: Replace with proper version
const EXTENSIONS_SUPPORTED = isdefined(Base, :get_extension)

if !EXTENSIONS_SUPPORTED
    using Requires: @require
    include("../ext/AbstractDifferentiationChainRulesCoreExt.jl")
end

@static if !EXTENSIONS_SUPPORTED
    function __init__()
        @require DiffResults = "163ba53b-c6d8-5494-b064-1a9d43ac40c5" begin
            @require ForwardDiff = "f6369f11-7733-5829-9624-2563aa707210" include(
                "../ext/AbstractDifferentiationForwardDiffExt.jl"
            )
            @require ReverseDiff = "37e2e3b7-166d-5795-8a7a-e32c996b4267" include(
                "../ext/AbstractDifferentiationReverseDiffExt.jl"
            )
        end
        @require FiniteDifferences = "26cc04aa-876d-5657-8c51-4c34ba976000" include(
            "../ext/AbstractDifferentiationFiniteDifferencesExt.jl"
        )
        @require Tracker = "9f7883ad-71c0-57eb-9f7f-b5c9e6d3789c" include(
            "../ext/AbstractDifferentiationTrackerExt.jl"
        )
        @require Zygote = "e88e6eb3-aa80-5325-afca-941959d7151f" include(
            "../ext/AbstractDifferentiationZygoteExt.jl"
        )
    end
end

end

# User guide

The list of functions on this page is the officially supported differentiation interface in `AbstractDifferentiation`.

## Loading `AbstractDifferentiation`

To load `AbstractDifferentiation`, it is recommended to use

```julia
import AbstractDifferentiation as AD
```

With the `AD` alias you can access names inside of `AbstractDifferentiation` using `AD.<>` instead of typing the long name `AbstractDifferentiation`.

## `AbstractDifferentiation` backends

To use `AbstractDifferentiation`, first construct a backend instance `ab::AD.AbstractBackend` using your favorite differentiation package in Julia that supports `AbstractDifferentiation`.

Here's an example:

```jldoctest
julia> import AbstractDifferentiation as AD, Zygote

julia> backend = AD.ZygoteBackend();

julia> f(x) = log(sum(exp, x));

julia> AD.gradient(backend, f, collect(1:3))
([0.09003057317038046, 0.2447284710547977, 0.665240955774822],)
```

The following backends are temporarily made available by `AbstractDifferentiation` as soon as their corresponding package is loaded (thanks to [weak dependencies](https://pkgdocs.julialang.org/dev/creating-packages/#Weak-dependencies) on Julia ≥ 1.9 and [Requires.jl](https://github.com/JuliaPackaging/Requires.jl) on older Julia versions):

```@docs
AbstractDifferentiation.ReverseDiffBackend
AbstractDifferentiation.ReverseRuleConfigBackend
AbstractDifferentiation.FiniteDifferencesBackend
AbstractDifferentiation.ZygoteBackend
AbstractDifferentiation.ForwardDiffBackend
AbstractDifferentiation.TrackerBackend
```

In the long term, these backend objects (and many more) will be defined within their respective packages to enforce the `AbstractDifferentiation` interface.
This is already the case for:

  - `Diffractor.DiffractorForwardBackend()` for [Diffractor.jl](https://github.com/JuliaDiff/Diffractor.jl) in forward mode

For higher order derivatives, you can build higher order backends using `AD.HigherOrderBackend`.

```@docs
AbstractDifferentiation.HigherOrderBackend
```

## Derivatives

The following list of functions can be used to request the derivative, gradient, Jacobian, second derivative or Hessian without the function value.

```@docs
AbstractDifferentiation.derivative
AbstractDifferentiation.gradient
AbstractDifferentiation.jacobian
AbstractDifferentiation.second_derivative
AbstractDifferentiation.hessian
```

## Value and derivatives

The following list of functions can be used to request the function value along with its derivative, gradient, Jacobian, second derivative, or Hessian. You can also request the function value, its derivative (or its gradient) and its second derivative (or Hessian) for single-input functions.

```@docs
AbstractDifferentiation.value_and_derivative
AbstractDifferentiation.value_and_gradient
AbstractDifferentiation.value_and_jacobian
AbstractDifferentiation.value_and_second_derivative
AbstractDifferentiation.value_and_hessian
AbstractDifferentiation.value_derivative_and_second_derivative
AbstractDifferentiation.value_gradient_and_hessian
```

## Jacobian-vector products

This operation goes by a few names, like "pushforward". Refer to the [ChainRules documentation](https://juliadiff.org/ChainRulesCore.jl/stable/#The-propagators:-pushforward-and-pullback) for more on terminology. For a single input, single output function `f` with a Jacobian `J`, the pushforward operator `pf_f` is equivalent to applying the function `v -> J * v` on a (tangent) vector `v`.

The following functions can be used to request a function that returns the pushforward operator/function. In order to request the pushforward function `pf_f` of a function `f` at the inputs `xs`, you can use either of:

```@docs
AbstractDifferentiation.pushforward_function
AbstractDifferentiation.value_and_pushforward_function
```

## Vector-Jacobian products

This operation goes by a few names, like "pullback". Refer to the [ChainRules documentation](https://juliadiff.org/ChainRulesCore.jl/stable/#The-propagators:-pushforward-and-pullback) for more on terminology. For a single input, single output function `f` with a Jacobian `J`, the pullback operator `pb_f` is equivalent to applying the function `v -> v' * J` on a (co-tangent) vector `v`.

The following functions can be used to request the pullback operator/function with or without the function value. In order to request the pullback function `pb_f` of a function `f` at the inputs `xs`, you can use either of:

```@docs
AbstractDifferentiation.pullback_function
AbstractDifferentiation.value_and_pullback_function
```

## Lazy operators

You can also get a struct for the lazy derivative/gradient/Jacobian/Hessian of a function. You can then use the `*` operator to apply the lazy operator on a value or tuple of the correct shape. To get a lazy derivative/gradient/Jacobian/Hessian use any one of:

```@docs
AbstractDifferentiation.lazy_derivative
AbstractDifferentiation.lazy_gradient
AbstractDifferentiation.lazy_jacobian
AbstractDifferentiation.lazy_hessian
```

## Index

```@index
```

# Implementer guide

!!! warning "Work in progress"
    
    Come back later!

## The macro `@primitive`

To implement the `AbstractDifferentiation` interface for your backend, you only _need_ to provide a "primitive" from which the rest of the functions can be deduced.
However, for performance reasons, you _can_ implement more of the interface to make certain calls faster.

At the moment, the only primitives supported are `AD.pushforward_function` and `AD.value_and_pullback_function`.
The `AD.@primitive` macro uses the provided function to implement `AD.jacobian`, and all the other functions follow.

```julia
AD.@primitive function AD.myprimitive(ab::MyBackend, f, xs...)
    # write your code here
end
```

See the backend-specific extensions in the `ext/` folder of the repository for example implementations.

## Function dependency graph

These details are not part of the public API and are expected to change.
They are just listed here to help readers figure out the code structure:

  - `jacobian` has no default implementation
  - `derivative` calls `jacobian`
  - `gradient` calls `jacobian`
  - `hessian` calls `jacobian` and `gradient`
  - `second_derivative` calls `derivative`
  - `value_and_jacobian` calls `jacobian`
  - `value_and_derivative` calls `value_and_jacobian`
  - `value_and_gradient` calls `value_and_jacobian`
  - `value_and_hessian` calls `jacobian` and `gradient`
  - `value_and_second_derivative` calls `second_derivative`
  - `value_gradient_and_hessian` calls `value_and_jacobian` and `gradient`
  - `value_derivative_and_second_derivative` calls `value_and_derivative` and `second_derivative`
  - `pushforward_function` calls `jacobian`
  - `value_and_pushforward_function` calls `pushforward_function`
  - `pullback_function` calls `value_and_pullback_function`
  - `value_and_pullback_function` calls `gradient`
